<?php

/**
 * IndexController - The default controller class
 * 
 * @author
 * @version 
 */

require_once 'Zend/Controller/Action.php';

class BookController extends Zend_Controller_Action 
{
	
    protected $_model;
	protected $_modelUser;
	
    public function indexAction() 
    {
		
		$model = $this->_getModel();
		$modelUser = $this->_getUsersModel();
		$request = $this->getRequest();
		$post_values=$request->getPost();
		$setPrinted=false;
		$this->entries=array();
		$this->user = Zend_Auth::getInstance()->getIdentity();
		if($this->_getParam("user")>0)
			$iduser=$this->_getParam("user");
		else
			$iduser=$this->user->id;
		if ($request->isPost()) {
			if($post_values['data_da_libro']!="" && $post_values['data_a_libro']!="")
				$this->entries = $model->getNotPrintedItemsByUserAndDate($iduser,$post_values['data_da_libro'],$post_values['data_a_libro']);
		}else{
			$this->entries = $model->getNotPrintedItemsByUser($iduser);
			$setPrinted=true;
		}
		
		$userData = $modelUser->fetchEntry($iduser);
		
		$num_pages=ceil(count($this->entries)/3);
		
		$modelUser->descreasePage($num_pages,$iduser);
		
		if($userData["pagine_libro"]<50){
			$data['data']=date('Y-m-d');
			$data['id_utente']=$iduser;
			$data['testo']="Le pagine del libro sono ".$userData["pagine_libro"]."!";
			$modelUser->sendMessage($data);
			$modelMail = $this->_getMailModel();
			$modelMail->sendMail($userData["email"],"Pagine in esaurimento","L'utente ".$userData["denominazione"]." sta finendo le pagine del libro. Pagine attuali:".$userData["pagine_libro"]);
		}
		
		$pdf = new Zend_Pdf(); 
		
		$diff[0]=0;
		$diff[1]=-149;
		$diff[2]=-298;
		$rowsNote=9;
		$charsNote=22;
		$rowLengthNote=14;
		
		$image = Zend_Pdf_Image::imageWithPath(APPLICATION_PATH."/media/setra.jpg"); 
 
 		for($i=0;$i<$num_pages;$i++){
			$page = $pdf->newPage(Zend_Pdf_Page::SIZE_A4_LANDSCAPE); 
			$page->drawImage($image, 50, 100, 784, 548); 
			$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
			$page->setFont($font, 10);
						
			for($j=0;$j<count($diff);$j++){
				$index=($i*count($diff))+$j;
				if($this->entries[$index]['progressivo']>0 || $this->entries[$index]['progressivo']=="0"){
					$sc=substr($this->entries[$index]['id'],0,1);
					$id=str_replace($sc,"",$this->entries[$index]['id']);
					$page->drawText($this->entries[$index]['progressivo'], 96, 505+$diff[$j]);
					if($sc=="s"){
						//FLAG SCARICO
						$page->drawText('X', 96, 538+$diff[$j]);
						
						$unloading=$model->fetchEntryUnload($id);
						$loading=$model->getLoadByUnloading($id);
						
						$arrData=explode("-",$unloading['data']);
						
						$page->drawText($arrData[2]."    ".$arrData[1]."      ".$arrData[0], 73, 522+$diff[$j]);
						
						$arrData=explode("-",$unloading['data_formulario']);
						
						$page->drawText($arrData[2]."    ".$arrData[1]."      ".$arrData[0], 73, 453+$diff[$j]);
						
						$page->drawText(substr($unloading['formulario_num'],0,50), 73, 472+$diff[$j]);
						
						$page->setFont($font, 8);
						$idx=0;
						$br=1;
						$index=0;
						foreach ($loading as $field) {
							$arrData=explode("-",$field["data"]);
							
							$page->drawText($field["progressivo"]." - ", 53+$idx, 427+$diff[$j]-($index*10));
							$idx+=15;
							if($br % 7==0){
								$index++;
								$idx=0;
							}
							$br++;
						}
						$page->setFont($font, 10);
						
						$page->drawText($loading[0]['cer'], 190, 529+$diff[$j]);
						$page->drawText(substr($loading[0]['descrizione'],0,50), 170, 501+$diff[$j]);
						$page->drawText(substr($loading[0]['stato_fisico'],0,50), 203, 473+$diff[$j]);
						$page->drawText(substr($loading[0]['classi_pericolosita'],0,50), 230, 460+$diff[$j]);
						
						if($loading[0]['cod_smaltimento_c']!=""){
							$page->drawText(substr($loading[0]['cod_smaltimento_c'],0,50), 222, 405+$diff[$j]);
							$page->drawText("X", 164, 401+$diff[$j]);
						}
						if($loading[0]['cod_recupero_c']!=""){
							$page->drawText(substr($loading[0]['cod_recupero_c'],0,50), 322, 405+$diff[$j]);
							$page->drawText("X", 273, 403+$diff[$j]);
						}
						
						if($loading[0]['unita_misura']=="Kg."){
							$page->drawText(substr($unloading['qt_dichiarata'],0,50), 400, 512+$diff[$j]);
						}else if($loading[0]['unita_misura']=="Litri"){
							$page->drawText(substr($unloading['qt_dichiarata'],0,50), 400, 475+$diff[$j]);
						}else if($loading[0]['unita_misura']=="Metri cubi"){
							$page->drawText(substr($unloading['qt_dichiarata'],0,50), 400, 441+$diff[$j]);
						}
						if($unloading['qt_destino']>0)
							$page->drawText(substr($unloading['qt_destino'],0,50), 400, 407+$diff[$j]);
						
						for($noteIndex=0;$noteIndex<$rowsNote;$noteIndex++){
							if(strlen($unloading['note'])>=($noteIndex*$charsNote))
								$page->drawText(substr($unloading['note'],($noteIndex*$charsNote),$charsNote), 676, 520+$diff[$j]-($noteIndex*$rowLengthNote));
						}
						$page->setFont($font, 8);
						$page->drawText(substr($userData['denominazione'],0,50)." C.F.".substr($userData['codice_fiscale'],0,50), 445, 527+$diff[$j]);
						$page->drawText(substr($userData['ubicazione_esercizio'],0,50), 445, 517+$diff[$j]);
						$page->drawText("Iscrizione Albo n.".substr($userData['num_iscrizione_albo'],0,50), 445, 507+$diff[$j]);
						if($unloading['id_trasportatore']>0)
						$transData = $modelUser->fetchEntry($unloading['id_trasportatore']);
						$page->drawText(substr($transData['denominazione'],0,50), 445, 465+$diff[$j]);
						$page->drawText(substr($transData['ubicazione_esercizio'],0,50), 445, 436+$diff[$j]);
						$page->drawText(substr($transData['codice_fiscale'],0,50), 463, 423+$diff[$j]);
						$page->drawText(substr($transData['num_iscrizione_albo'],0,50), 486, 405+$diff[$j]);
						$page->setFont($font, 10);
						if($setPrinted)
							$model->modifyUnload(array('stampato' => 1),$id);
						
					}else{				
						//FLAG CARICO
						$page->drawText('X', 150, 538+$diff[$j]);
					
					
						$loading=$model->getLoading($id);
						
						
						
						$arrData=explode("-",$loading[0]['data']);
						
						$page->drawText($arrData[2]."    ".$arrData[1]."      ".$arrData[0], 73, 522+$diff[$j]);
						
						$page->drawText($loading[0]['cer'], 190, 529+$diff[$j]);
						$page->drawText(substr($loading[0]['descrizione'],0,50), 170, 501+$diff[$j]);
						$page->drawText(substr($loading[0]['stato_fisico'],0,50), 203, 473+$diff[$j]);
						$page->drawText(substr($loading[0]['classi_pericolosita'],0,50), 230, 460+$diff[$j]);
						
						if($loading[0]['cod_smaltimento_c']!=""){
							$page->drawText(substr($loading[0]['cod_smaltimento_c'],0,50), 222, 405+$diff[$j]);
							$page->drawText("X", 164, 401+$diff[$j]);
						}
						if($loading[0]['cod_recupero_c']!=""){
							$page->drawText(substr($loading[0]['cod_recupero_c'],0,50), 322, 405+$diff[$j]);
							$page->drawText("X", 273, 403+$diff[$j]);
						}
						
						if($loading[0]['unita_misura']=="Kg."){
							$page->drawText(substr($loading[0]['quantita'],0,50), 400, 512+$diff[$j]);
						}else if($loading[0]['unita_misura']=="Litri"){
							$page->drawText(substr($loading[0]['quantita'],0,50), 400, 475+$diff[$j]);
						}else if($loading[0]['unita_misura']=="Metri cubi"){
							$page->drawText(substr($loading[0]['quantita'],0,50), 400, 441+$diff[$j]);
						}
						for($noteIndex=0;$noteIndex<$rowsNote;$noteIndex++){
							if(strlen($loading[0]['note'])>=($noteIndex*$charsNote))
								$page->drawText(substr($loading[0]['note'],($noteIndex*$charsNote),$charsNote), 676, 520+$diff[$j]-($noteIndex*$rowLengthNote));
						}
						$page->setFont($font, 8);
						$page->drawText(substr($userData['denominazione'],0,50)." C.F.".substr($userData['codice_fiscale'],0,50), 445, 527+$diff[$j]);
						$page->drawText(substr($userData['ubicazione_esercizio'],0,50), 445, 517+$diff[$j]);
						$page->drawText("Iscrizione Albo n.".substr($userData['num_iscrizione_albo'],0,50), 445, 507+$diff[$j]);
						$page->setFont($font, 10);
						if($setPrinted)
							$model->modify(array('stampato' => 1),$id);
							
						if($loading[0]['quantita']<0){
							$page->setLineWidth(3);
							$page->drawLine(50,547+$diff[$j],784,400+$diff[$j]);
							$page->drawLine(784,547+$diff[$j],50,400+$diff[$j]);
						}
					}
				}else{
					$page->setLineWidth(3);
					$page->drawLine(50,547+$diff[$j],784,400+$diff[$j]);
					$page->drawLine(784,547+$diff[$j],50,400+$diff[$j]);
				}
			}
			
			
			$pdf->pages[] = $page;
			unset($page);
		}
		
		
		$pdfData = $pdf->render(); 
		
		header("Content-Disposition: inline; filename=result.pdf"); 
		header("Content-type: application/x-pdf"); 
		echo $pdfData; 

    }
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/login'); 
        } 
    }
	
	
	
	protected function _getModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Loading.php';
            $this->_model = new Model_Loading();
        }
        return $this->_model;
    }
	
	protected function _getUsersModel()
    {
        if (null === $this->_modelUser) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_modelUser = new Model_Users();
        }
        return $this->_modelUser;
    }
	
	protected function _getMailModel()
    {
        if (null === $this->_modelMail) {
            require_once APPLICATION_PATH . '/models/Mail.php';
            $this->_modelMail = new Model_Mail();
        }
        return $this->_modelMail;
    }
	
}
?>