<?php

/**
 * IndexController - The default controller class
 * 
 * @author
 * @version 
 */

require_once 'Zend/Controller/Action.php';

class IndexController extends Zend_Controller_Action 
{
	/**
	 * The default action - show the home page
	 */
    public function indexAction() 
    {
        $this->initView(); 
        $this->view->baseUrl = $this->_request->getBaseUrl(); 
        $this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$modelLoads = $this->_getLoadingModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->messages=$modelUsers->getMessages($this->view->user->id);
		
		$loadsSearchSess=new Zend_Session_Namespace('loads');
		$loadsSearchSess->note="";
		$loadsSearchSess->data_da="";
		$loadsSearchSess->data_a="";
		$loadsSearchSess->selCarico="";
		$loadsSearchSess->rifiuto="";
		
		$unloadsSearchSess=new Zend_Session_Namespace('unloads');
		$unloadsSearchSess->note="";
		$unloadsSearchSess->data_da="";
		$unloadsSearchSess->data_a="";
		$unloadsSearchSess->rifiuto="";
		$unloadsSearchSess->formulario_num="";
		
		$reportSearchSess=new Zend_Session_Namespace('report');
		$reportSearchSess->rifiuto="";
		$reportSearchSess->data_da="";
		$reportSearchSess->data_a="";
		
		$usersSearchSess=new Zend_Session_Namespace('users');
		$usersSearchSess->nome="";
		$usersSearchSess->ruolo="";
		
		$wasteSearchSess=new Zend_Session_Namespace('waste');
		$wasteSearchSess->nome="";
		
		$loadEntries = $modelLoads->getNotPrintedItemsByUser($this->view->user->id);
		if(count($loadEntries)<=0){
			$this->view->user->book=false;
		}else{
			$this->view->user->book=true;
		}
		
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray);
		if(!$this->view->user->role['AMM']){
			$userData = $modelUsers->fetchEntry($this->view->user->id);
			$oDT = strtotime(date("Y-m-d"));
			$aDT = strtotime($userData['data_attivazione']);
			$oDTDiff = $oDT - $aDT;
			$userData['giorni_attivazione']=$userData['giorni_attivazione']-($oDTDiff/24/60/60);
			$userData['data_attivazione']=date("Y-m-d");
			if($userData['giorni_attivazione']<=0){
				$userData['giorni_attivazione']=0;
				$modelUsers->modify($userData,$this->view->user->id,$this->view->user->id);
				$this->_redirect('auth/login/message/expired'); 
			}else
				$modelUsers->modify($userData,$this->view->user->id,$this->view->user->id);
		}
    }
	
	public function deletemessageAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$msgid=$this->_getParam('item');
		$model = $this->_getUsersModel();
		$model->deleteMessage($msgid);
		return $this->_helper->redirector->gotoUrl('/');
    }
	
	protected function _getLoadingModel()
    {
        if (null === $this->_modelLoading) {
            require_once APPLICATION_PATH . '/models/Loading.php';
            $this->_modelLoading = new Model_Loading();
        }
        return $this->_modelLoading;
    }
	
	protected function _getUsersModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_model = new Model_Users();
        }
        return $this->_model;
    }
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/login'); 
        } 
    }
	
}
?>