<?php

require_once APPLICATION_PATH . '/forms/LoadingForm.php';
require_once APPLICATION_PATH . '/forms/UnloadingForm.php';
require_once APPLICATION_PATH . '/forms/TransForm.php';
require_once APPLICATION_PATH . '/forms/DestForm.php';

class LoadingController extends Zend_Controller_Action 
{
    protected $_model;
	protected $_modelUsers;
	protected $_modelWaste;
	protected $_modelMail;
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/login'); 
        } 
    }
	
	private function resetSessions(){
		$loadsSearchSess=new Zend_Session_Namespace('loads');
		$loadsSearchSess->selCarico="";
		$loadsSearchSess->note="";
		$loadsSearchSess->data_da="";
		$loadsSearchSess->data_a="";
		$loadsSearchSess->rifiuto="";
		$loadsSearchSess->scaricato="";
		$unloadsSearchSess=new Zend_Session_Namespace('unloads');
		$unloadsSearchSess->note="";
		$unloadsSearchSess->data_da="";
		$unloadsSearchSess->data_a="";
		$unloadsSearchSess->rifiuto="";
		$unloadsSearchSess->formulario_num="";
		$reportSearchSess=new Zend_Session_Namespace('report');
		$reportSearchSess->rifiuto="";
		$reportSearchSess->data_da="";
		$reportSearchSess->data_a="";
	}
	
	public function reportallAction()
    {
        $model = $this->_getModel();
		$modelUsers = $this->_getUsersModel();
		$modelWaste = $this->_getWasteModel();
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$request = $this->getRequest();
		$reportSearchSess=new Zend_Session_Namespace('report');
		$this->view->waste=$modelWaste->fetchEntries();
		$this->view->entries=array();
		
		$isAdm=($this->view->user->role['AMM']==1);
		
			
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		
		if ($request->isPost()) {
			$post_values=$request->getPost();
			if($post_values['rifiuto']!=""){
				$reportSearchSess->rifiuto=$post_values['rifiuto'];
			}
			if($post_values['data_da']!=""){
				$reportSearchSess->data_da=$post_values['data_da'];
			}
			if($post_values['data_a']!=""){
				$reportSearchSess->data_a=$post_values['data_a'];
			}
			if($post_values['resetta']=="1"){
				$this->resetSessions();
			}
			if($post_values['ipp']!=""){
				$reportSearchSess->ipp=$post_values['ipp'];
			}
		}
		
		if($reportSearchSess->ipp<=0)
			$reportSearchSess->ipp=10;
		
		if($reportSearchSess->rifiuto<=0){
			if($this->view->waste[0]['id']>0)
				$reportSearchSess->rifiuto=$this->view->waste[0]['id'];
			else
				$reportSearchSess->rifiuto=-1;
		}
		if($reportSearchSess->data_da!="" && $reportSearchSess->data_a==""){
			$this->entries = $model->getItemsByWasteAndDate($reportSearchSess->rifiuto,$reportSearchSess->data_da,date("Y-m-d"));
			$reportSearchSess->data_a=date("Y-m-d");
		}else
		if($reportSearchSess->data_da=="" && $reportSearchSess->data_a!=""){
			$this->entries = $model->getItemsByWasteAndDate($reportSearchSess->rifiuto,date("Y-01-01"),$reportSearchSess->data_a);
			$reportSearchSess->data_da=date("Y-01-01");
		}else
		if($reportSearchSess->data_da!="" && $reportSearchSess->data_a!=""){
			$this->entries = $model->getItemsByWasteAndDate($reportSearchSess->rifiuto,$reportSearchSess->data_da,$reportSearchSess->data_a);
		}else{
			$this->entries = $model->getItemsByWasteAndDate($reportSearchSess->rifiuto,date("Y-01-01"),date("Y-m-d"));
			$reportSearchSess->data_da=date("Y-01-01");
			$reportSearchSess->data_a=date("Y-m-d");
		}
		
		
		$this->view->totCarichi=0;
		$this->view->totScarichiDic=0;
		$this->view->totScarichiDes=0;
		$this->view->totale=0;
		foreach ($this->entries as $item){
			if($item['progressivo']>0 || $item['progressivo']=="0"){
				$sc=substr($item['id'],0,1);
				$id=str_replace($sc,"",$item['id']);
				if($sc=="s"){
					$items=$model->getUnloading($id);
					$items[0]["user"]=$modelUsers->fetchEntry($items[0]["id_utente"]);
					$this->view->entries[]=$items;
					$this->view->totScarichiDic+=$items[0]['qt_dichiarata'];
					$this->view->totScarichiDes+=$items[0]['qt_destino'];
				}else if($sc=="c"){
					$items=$model->getLoading($id);
					$items[0]["user"]=$modelUsers->fetchEntry($items[0]["id_utente"]);
					$this->view->entries[]=$items;
					$this->view->totCarichi+=$items[0]['quantita'];
				}
			}
		}
		$this->view->totale=$this->view->totScarichiDes-$this->view->totCarichi;
		
		$paginator = new Zend_Paginator(new Zend_Paginator_Adapter_Array($this->view->entries));
		$paginator->setItemCountPerPage($reportSearchSess->ipp);
		$paginator->setCurrentPageNumber($this->_getParam("page"));
		
		$this->view->reportSearchSess=$reportSearchSess;
		$this->view->paginator=$paginator;
    }
	
	public function reportAction()
    {
        $model = $this->_getModel();
		$modelUsers = $this->_getUsersModel();
		$modelWaste = $this->_getWasteModel();
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$request = $this->getRequest();
		$reportSearchSess=new Zend_Session_Namespace('report');
		$this->view->waste=$modelUsers->getWasteByUser($this->_getParam("user"));
		$this->view->entries=array();
		
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
			
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		
		if ($request->isPost()) {
			$post_values=$request->getPost();
			if($post_values['rifiuto']!=""){
				$reportSearchSess->rifiuto=$post_values['rifiuto'];
			}
			if($post_values['data_da']!=""){
				$reportSearchSess->data_da=$post_values['data_da'];
			}
			if($post_values['data_a']!=""){
				$reportSearchSess->data_a=$post_values['data_a'];
			}
			if($post_values['resetta']=="1"){
				$this->resetSessions();
			}
		}
		
		if($reportSearchSess->rifiuto<=0){
			if($this->view->waste[0]['id']>0)
				$reportSearchSess->rifiuto=$this->view->waste[0]['id'];
			else
				$reportSearchSess->rifiuto=-1;
		}
		if($reportSearchSess->data_da!="" && $reportSearchSess->data_a==""){
			$this->entries = $model->getItemsByUserAndWasteAndDate($this->_getParam("user"),$reportSearchSess->rifiuto,$reportSearchSess->data_da,date("Y-m-d"));
			$reportSearchSess->data_a=date("Y-m-d");
		}else
		if($reportSearchSess->data_da=="" && $reportSearchSess->data_a!=""){
			$this->entries = $model->getItemsByUserAndWasteAndDate($this->_getParam("user"),$reportSearchSess->rifiuto,date("Y-01-01"),$reportSearchSess->data_a);
			$reportSearchSess->data_da=date("Y-01-01");
		}else
		if($reportSearchSess->data_da!="" && $reportSearchSess->data_a!=""){
			$this->entries = $model->getItemsByUserAndWasteAndDate($this->_getParam("user"),$reportSearchSess->rifiuto,$reportSearchSess->data_da,$reportSearchSess->data_a);
		}else{
			$this->entries = $model->getItemsByUserAndWasteAndDate($this->_getParam("user"),$reportSearchSess->rifiuto,date("Y-01-01"),date("Y-m-d"));
			$reportSearchSess->data_da=date("Y-01-01");
			$reportSearchSess->data_a=date("Y-m-d");
		}
		
		
		$this->view->totCarichi=0;
		$this->view->totScarichiDic=0;
		$this->view->totScarichiDes=0;
		$this->view->totale=0;
		foreach ($this->entries as $item){
			if($item['progressivo']>0 || $item['progressivo']=="0"){
				$sc=substr($item['id'],0,1);
				$id=str_replace($sc,"",$item['id']);
				if($sc=="s"){
					$items=$model->getUnloading($id);
					$this->view->entries[]=$items;
					$this->view->totScarichiDic+=$items[0]['qt_dichiarata'];
					$this->view->totScarichiDes+=$items[0]['qt_destino'];
				}else if($sc=="c"){
					$items=$model->getLoading($id);
					$this->view->entries[]=$items;
					$this->view->totCarichi+=$items[0]['quantita'];
				}
			}
		}
		$this->view->totale=$this->view->totScarichiDes-$this->view->totCarichi;
		
		$paginator = new Zend_Paginator(new Zend_Paginator_Adapter_Array($this->view->entries));
		$paginator->setCurrentPageNumber($this->_getParam("page"));
		
		$this->view->reportSearchSess=$reportSearchSess;
		$this->view->paginator=$paginator;
		$this->view->userid=$this->_getParam("user");
    }

    public function indexAction()
    {
        $model = $this->_getModel();
		$modelUsers = $this->_getUsersModel();
		$modelWaste = $this->_getWasteModel();
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$request = $this->getRequest();
		$loadsSearchSess=new Zend_Session_Namespace('loads');
		$this->view->entries=array();
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
			
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		
		if ($this->getRequest()->isGet()) {
			$get_values=$request->getQuery();
			if($get_values['order']!=""){
				$loadsSearchSess->order=$get_values['order'];
				$loadsSearchSess->dir=($loadsSearchSess->dir=="desc")?$loadsSearchSess->dir="asc":$loadsSearchSess->dir="desc";
			}else{
				if($loadsSearchSess->order==""){
					$loadsSearchSess->order="descrizione";
					$loadsSearchSess->dir="desc";
				}
			}
		}
		
		$selected="";
		if ($request->isPost()) {
			$post_values=$request->getPost();
			$selected=$post_values['selected'];
			if($post_values['selected']!='all'){
				if($loadsSearchSess->selCarico[$post_values['selected']]==0)
					$loadsSearchSess->selCarico[$post_values['selected']]=1;
				else
					$loadsSearchSess->selCarico[$post_values['selected']]=0;
			}
			if($post_values['selected']=='all')
				$loadsSearchSess->selCarico['all']=1;
			else
				$loadsSearchSess->selCarico['all']=0;
			
			if($post_values['note']!=""){
				$this->resetSessions();
				$loadsSearchSess->note=$post_values['note'];
			}
			if($post_values['data_da']!="" && $post_values['data_a']!=""){
				$this->resetSessions();
				$loadsSearchSess->data_da=$post_values['data_da'];
				$loadsSearchSess->data_a=$post_values['data_a'];
			}
			if($post_values['rifiuto']!=""){
				$this->resetSessions();
				$loadsSearchSess->rifiuto=$post_values['rifiuto'];
				$loadsSearchSess->scaricato=$post_values['scaricato'];
			}
			
			if($post_values['resetta']=="1"){
				$this->resetSessions();
			}
		}
		
		if($loadsSearchSess->note!=""){
			$this->view->entries = $model->getLoadingByUserAndNote($this->_getParam("user"),$loadsSearchSess->note,$loadsSearchSess->order,$loadsSearchSess->dir);			
		}else
		if($loadsSearchSess->rifiuto!=""){
			$this->view->entries = $model->getLoadingByUserAndWaste($this->_getParam("user"),$loadsSearchSess->rifiuto,$loadsSearchSess->scaricato,$loadsSearchSess->order,$loadsSearchSess->dir);
		}else
		if($loadsSearchSess->data_da!="" && $loadsSearchSess->data_a!=""){
			$this->view->entries = $model->getLoadingByUserAndDate($this->_getParam("user"),$loadsSearchSess->data_da,$loadsSearchSess->data_a,$loadsSearchSess->order,$loadsSearchSess->dir);
		}else
		{
			$this->view->entries = $model->getLoadingByUser($this->_getParam("user"),$loadsSearchSess->order,$loadsSearchSess->dir);
		}
		
		$this->view->bCheck=array();
		foreach ($this->view->entries as $item){
			if(count($model->getUnloadByLoading($item['id_carico']))>0){
				$this->view->bCheck[$item['id_carico']]=0;
			}else{
				$this->view->bCheck[$item['id_carico']]=1;
				if($selected=='all'){
					$loadsSearchSess->selCarico[$item['id_carico']]=1;
				}else if($selected=='none'){
					$loadsSearchSess->selCarico[$item['id_carico']]=0;
				}
			}
		}
		
		$paginator = new Zend_Paginator(new Zend_Paginator_Adapter_Array($this->view->entries));
		$paginator->setCurrentPageNumber($this->_getParam("page"));
		
		$this->view->loadsSearchSess=$loadsSearchSess;
		$this->view->paginator=$paginator;
		$this->view->userid=$this->_getParam("user");
		$this->view->waste=$modelUsers->getWasteByUser($this->view->userid);
    }
	
	public function indexunloadAction()
    {	
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		
		$model = $this->_getModel();
		$modelWaste = $this->_getWasteModel();
		$request = $this->getRequest();
		$unloadsSearchSess=new Zend_Session_Namespace('unloads');
		$this->view->entries=array();
		
		if ($this->getRequest()->isGet()) {
			$get_values=$request->getQuery();
			if($get_values['order']!=""){
				$unloadsSearchSess->order=$get_values['order'];
				$unloadsSearchSess->dir=($unloadsSearchSess->dir=="desc")?$unloadsSearchSess->dir="asc":$unloadsSearchSess->dir="desc";
			}else{
				if($unloadsSearchSess->order==""){
					$unloadsSearchSess->order="descrizione";
					$unloadsSearchSess->dir="desc";
				}
			}
		}
		
		
		if ($request->isPost()) {
			$post_values=$request->getPost();
				
			
			if($post_values['note']!=""){
				$this->resetSessions();
				$unloadsSearchSess->note=$post_values['note'];
			}
			if($post_values['data_da']!="" && $post_values['data_a']!=""){
				$this->resetSessions();
				$unloadsSearchSess->data_da=$post_values['data_da'];
				$unloadsSearchSess->data_a=$post_values['data_a'];
			}
			if($post_values['formulario_num_p1']!="" || $post_values['formulario_num_p2']!="" || $post_values['formulario_num_p3']!=""){
				$this->resetSessions();
				if($post_values['formulario_num_p1']!="")
				$unloadsSearchSess->formulario_num=$post_values['formulario_num_p1'];
				if($post_values['formulario_num_p2']!="")
				$unloadsSearchSess->formulario_num.=' '.$post_values['formulario_num_p2'];
				else
				$unloadsSearchSess->formulario_num.='%';
				if($post_values['formulario_num_p3']!="")
				$unloadsSearchSess->formulario_num.='/'.$post_values['formulario_num_p3'];
			}
			if($post_values['rifiuto']!=""){
				$this->resetSessions();
				$unloadsSearchSess->rifiuto=$post_values['rifiuto'];
				$unloadsSearchSess->scaricato=$post_values['scaricato'];
			}
			
			if($post_values['resetta']=="1"){
				$this->resetSessions();
			}
		}
		
		if($unloadsSearchSess->note!=""){
			$this->view->entries = $model->getUnloadingByUserAndNote($this->_getParam("user"),$unloadsSearchSess->note,$unloadsSearchSess->order,$unloadsSearchSess->dir);			
		}else
		if($unloadsSearchSess->rifiuto!=""){
			$this->view->entries = $model->getUnloadingByUserAndWaste($this->_getParam("user"),$unloadsSearchSess->rifiuto,$unloadsSearchSess->scaricato,$unloadsSearchSess->order,$unloadsSearchSess->dir);
		}else
		if($unloadsSearchSess->formulario_num!=""){
			$this->view->entries = $model->getUnloadingByUserAndFormulario($this->_getParam("user"),$unloadsSearchSess->formulario_num,$unloadsSearchSess->order,$unloadsSearchSess->dir);			
		}else
		if($unloadsSearchSess->data_da!="" && $unloadsSearchSess->data_a!=""){
			$this->view->entries = $model->getUnloadingByUserAndDate($this->_getParam("user"),$unloadsSearchSess->data_da,$unloadsSearchSess->data_a,$unloadsSearchSess->order,$unloadsSearchSess->dir);
		}else
		{
			$this->view->entries = $model->getUnloadingByUser($this->_getParam("user"),$unloadsSearchSess->order,$unloadsSearchSess->dir);
		}
		
		
		$paginator = new Zend_Paginator(new Zend_Paginator_Adapter_Array($this->view->entries));
		$paginator->setCurrentPageNumber($this->_getParam("page"));
		
		$this->view->unloadsSearchSess=$unloadsSearchSess;
		$this->view->paginator=$paginator;
		$this->view->userid=$this->_getParam("user");
		$this->view->waste=$modelUsers->getWasteByUser($this->view->userid);
    }
	
	public function userlistAction()
    {
        $modelUsers = $this->_getUsersModel();

        $result = $modelUsers->fetchAll("denominazione","asc");
		
        $data = new Zend_Dojo_Data('id', $result);
		
        $this->_helper->autoCompleteDojo($data);
         
    }
	
	public function translistAction()
    {
        $modelUsers = $this->_getUsersModel();
		$result=$modelUsers->getTransByUser($this->_getParam("user"));
        $data = new Zend_Dojo_Data('id', $result);
		
        $this->_helper->autoCompleteDojo($data);
         
    }
	
	public function destlistAction()
    {
        $modelUsers = $this->_getUsersModel();
		$result=$modelUsers->getDestByUser($this->_getParam("user"));
        $data = new Zend_Dojo_Data('id', $result);
		
        $this->_helper->autoCompleteDojo($data);
         
    }
	
	public function newAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Loading();
		$form->setWasteSelect($this->_getParam("user"));

        $form->setAction($this->_helper->url('new/user/'.$this->_getParam("user")));
		$modelUsers = $this->_getUsersModel();
		$model = $this->_getModel();
		
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		
		$user=$modelUsers->fetchEntry($this->_getParam("user"));
		
		if($user['ultima_operazione']!=""){
			$sc_um=substr($user['ultima_operazione'],0,1);
			$id_um=str_replace($sc_um,"",$user['ultima_operazione']);
			
			if($sc_um=="s"){
				$lastLoad=$model->fetchEntryUnload($id_um);
			}else if($sc_um=="c"){
				$lastLoad=$model->fetchEntry($id_um);
			}
			
			$arrData=explode("-",$lastLoad["data"]);
			if($arrData[0]<date("Y") && $arrData[0]!="")
				$user['progressivo']=-1;
		}
		
		$form->setProgressivo($user['progressivo']+1);
		
        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
				$modelWaste = $this->_getWasteModel();
				$data=$form->getValues();
				
				$countData=count($model->getLoadingByUserAndDateAndWaste($this->_getParam("user"),$data['id_rifiuto'],$data['data'],$data['data']));
				
				if($countData>0){
					$form->_data->addError("Carico esistente per questa data!")->render();
				}else{
					$data['id_utente']=$this->_getParam("user");
					$wasteData=$modelWaste->fetchEntry($form->getWaste());
					$data['cod_smaltimento']=$wasteData['cod_smaltimento'];
					$data['cod_recupero']=$wasteData['cod_recupero'];
					$note=$modelUsers->getNote($this->_getParam("user"));
					if($note[0]['nota']!=""){
						if($data['note']!=""){
							$data['note']=$data['note']."  ------  ";
						}
						$data['note']=$data['note'].$note[0]['nota'];
						$modelUsers->deleteNote($note[0]['id']);
					}
					$lId=$model->save($data);
					$dataUser['progressivo']=$user['progressivo']+1;
					$dataUser['ultima_operazione']="c".$lId;
					$modelUsers->modify($dataUser,$this->_getParam("user"),$this->view->user->id);
					if($data['print']==0)
						return $this->_helper->redirector->gotoUrl('loading/index/user/'.$this->_getParam('user'));
					else
						return $this->_helper->redirector->gotoUrl('book');
				}
            }
        }
		
		$this->view->userid=$this->_getParam('user');
        $this->view->form = $form;
    }
	
	public function modifyAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$loadingid=$this->_getParam('item');
		$request = $this->getRequest();
        $form = new Form_Loading();
		$form->setWasteSelect($this->_getParam("user"));
        $form->setAction($this->_helper->url('modify/user/'.$this->_getParam("user").'/item/'.$loadingid));
		$model = $this->_getModel();
		$data=$model->fetchEntry($loadingid);
		
		$form->populate($data);

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
				$modelWaste = $this->_getWasteModel();
				$data=$form->getValues();
				$data['id_utente']=$this->_getParam("user");
				$wasteData=$modelWaste->fetchEntry($form->getWaste());
				$data['cod_smaltimento']=$wasteData['cod_smaltimento'];
				$data['cod_recupero']=$wasteData['cod_recupero'];
				
                $model->modify($data,$loadingid);
                
                return $this->_helper->redirector->gotoUrl('loading/index/user/'.$this->_getParam('user'));
            }
        }
        $this->view->userid=$this->_getParam('user');
        $this->view->form = $form;
    }
	
	public function modifyunloadAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$loadingid=$this->_getParam('item');
        $request = $this->getRequest();
        $form = new Form_Unloading();
		$model = $this->_getModel();
        $form->setAction($this->_helper->url('modifyunload/user/'.$this->_getParam("user").'/item/'.$loadingid));
		
		$data=$model->fetchEntryUnload($loadingid);
		
		$qtDestino=$data['qt_destino'];
		$stampato=$data['stampato'];
		
		$fnp1=explode(" ",$data['formulario_num']);
		$fnp2=explode("/",$fnp1[1]);
		$data['formulario_num_p1']=$fnp1[0];
		$data['formulario_num_p2']=$fnp2[0];
		$data['formulario_num_p3']=$fnp2[1];
		
		$form->setTrans(51);
		
		$form->populate($data);
		
		$this->view->loads=array();
		
		$this->view->loads=$model->getLoadByUnloading($loadingid);
		
		$modelUsers = $this->_getUsersModel();
		$user=$modelUsers->fetchEntry($this->_getParam("user"));
		
		if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
				$modelWaste = $this->_getWasteModel();
				$data=$form->getValues();
				$data['formulario_num_p1']=str_replace(" ","",$data['formulario_num_p1']);
				$data['formulario_num_p1']=str_replace("/","",$data['formulario_num_p1']);
				$data['formulario_num_p2']=str_replace(" ","",$data['formulario_num_p2']);
				$data['formulario_num_p2']=str_replace("/","",$data['formulario_num_p2']);
				$data['formulario_num_p3']=str_replace(" ","",$data['formulario_num_p3']);
				$data['formulario_num_p3']=str_replace("/","",$data['formulario_num_p3']);
				$data['formulario_num']=$data['formulario_num_p1'].' '.$data['formulario_num_p2'].'/'.$data['formulario_num_p3'];
				$model->modifyUnload($data,$loadingid);

				if($data['qt_destino']!=$qtDestino && $stampato==1){
					$note['id_utente']=$this->_getParam("user");
					$udm=$model->getUdm($data['id_um_qtr']);
					$note['nota']="Peso a destino modificato nel progressivo N.".$data['progressivo']." Formulario N.".$data['formulario_num']." in ".$udm['unita_misura']." ".$data['qt_destino'];
					$modelUsers->newNote($note);
				}
                return $this->_helper->redirector->gotoUrl('loading/indexunload/user/'.$this->_getParam('user'));
            }
        }
		
		$this->view->userid=$this->_getParam('user');
        $this->view->form = $form;
    }
	
	public function unloadAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$request = $this->getRequest();
        $form = new Form_Unloading();
		$loadsSearchSess=new Zend_Session_Namespace('loads');
		
		
		//BUG FIX IE 
		session_start();
		if ($this->getRequest()->isPost()) {
			$loadsSearchSess->selCarico=$_SESSION["selCarico"];
			//$_SESSION["selCarico"]="";	
		}else{
			$_SESSION["selCarico"]=$loadsSearchSess->selCarico;
		}
		//END BUG FIX IE
		
		$this->view->loads=array();
		
		$model = $this->_getModel();
        $form->setAction($this->_helper->url('unload/user/'.$this->_getParam("user")));
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$user=$modelUsers->fetchEntry($this->_getParam("user"));
		
		if($user['ultima_operazione']!=""){
			$sc_um=substr($user['ultima_operazione'],0,1);
			$id_um=str_replace($sc_um,"",$user['ultima_operazione']);
			
			if($sc_um=="s"){
				$lastLoad=$model->fetchEntryUnload($id_um);
			}else if($sc_um=="c"){
				$lastLoad=$model->fetchEntry($id_um);
			}
			
			$arrData=explode("-",$lastLoad["data"]);
			if($arrData[0]<date("Y") && $arrData[0]!="")
				$user['progressivo']=-1;
		}
		$form->setProgressivo($user['progressivo']+1);
		$form->setTrans($this->view->user->id);
		
		foreach ($loadsSearchSess->selCarico as $key => $item){
			if($loadsSearchSess->selCarico[$key]==1 && $key!="all" && $key!="none"){
				$items=$model->getLoading($key);
				$this->view->loads[]=$items;
				$qtDichiarata+=$items[0]["quantita"];
			}
		}
		
		
		if(count($this->view->loads)<=0 || $items[0]["id_rifiuto"]<=0){
			return $this->_helper->redirector->gotoUrl('loading/index/user/'.$this->_getParam('user'));
		}
		
		$form->setQtDichiarata($qtDichiarata);
		
		if ($this->getRequest()->isPost()) {
			if ($form->isValid($request->getPost())) {
				$modelWaste = $this->_getWasteModel();
				
				$data=$form->getValues();
				$data['id_utente']=$this->_getParam("user");
				$data['formulario_num_p1']=str_replace(" ","",$data['formulario_num_p1']);
				$data['formulario_num_p1']=str_replace("/","",$data['formulario_num_p1']);
				$data['formulario_num_p2']=str_replace(" ","",$data['formulario_num_p2']);
				$data['formulario_num_p2']=str_replace("/","",$data['formulario_num_p2']);
				$data['formulario_num_p3']=str_replace(" ","",$data['formulario_num_p3']);
				$data['formulario_num_p3']=str_replace("/","",$data['formulario_num_p3']);
				$data['formulario_num']=$data['formulario_num_p1'];
				if($data['formulario_num_p2']!="")
					$data['formulario_num'].=' '.$data['formulario_num_p2'];
				if($data['formulario_num_p3']!="")
					$data['formulario_num'].='/'.$data['formulario_num_p3'];
				
				$countFormulari=count($model->getUnloadingByFormulario($data['formulario_num']));
				
				if($countFormulari>0){
					$form->_formulario->addError("N. Formulario esistente!")->render();
				}else{
					$loads=array();
					if($data['qt_destino']>0 && $items[0]["id_rifiuto"]>0 && $data['checkqt']==1 && ($data['qt_destino']!=$data['qt_dichiarata'])){
						$dataLoad["data"]=$data['data'];
						$dataLoad["progressivo"]=$data['progressivo'];
						$user['progressivo']=$data['progressivo'];
						$data['progressivo']=$data['progressivo']+1;
						$dataLoad["quantita"]=$data['qt_destino']-$data['qt_dichiarata'];
						$dataLoad["id_unita_di_misura"]=$data['id_um_qtr'];
						$dataLoad["id_rifiuto"]=$items[0]["id_rifiuto"];
						$dataLoad["id_utente"]=$this->_getParam('user');
						$dataLoad["cod_smaltimento"]=$items[0]["cod_smaltimento"];
						$dataLoad["cod_recupero"]=$items[0]["cod_recupero"];
						$tId=$model->save($dataLoad);
						$loads[]['id']=$tId;
						if($dataLoad["quantita"]<0)
							$data['note']="Il carico presunto effettuato risulta in eccesso di Kg. ".($dataLoad["quantita"]*-1)." da quello effettivamente rilevato a destino.";
					}
					
					$lId=$model->saveUnload($data);
					
					if($data['qt_destino']<=0){
						$data['data']=date('Y-m-d');
						$data['id_utente']=$this->_getParam('user');
						$data['testo']="Peso a destino mancante nel progressivo N.".$data['progressivo']." del ".$data['data']." Formulario N.".$data['formulario_num'];
						$data['url']="/loading/modifyunload/user/".$this->_getParam('user')."/item/".$lId;
						$modelUsers->sendMessage($data);
					}
					$dataUser['progressivo']=$user['progressivo']+1;
					$dataUser['ultima_operazione']="s".$lId;
					$modelUsers->modify($dataUser,$this->_getParam("user"),$this->view->user->id);
					
					foreach ($loadsSearchSess->selCarico as $key => $item){
						if($loadsSearchSess->selCarico[$key]==1 && $key!="all" && $key!="none")
							$loads[]['id']=$key;
					}
					
					$model->saveLoads($lId,$loads);	
					$this->resetSessions();	
					return $this->_helper->redirector->gotoUrl('loading/index/user/'.$this->_getParam('user'));
				}
				
            }
        }
		
		$this->view->userid=$this->_getParam('user');
        $this->view->form = $form;
    }
	
	public function delloadunloadAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$unloadingid=$this->_getParam('item');
		$loadingid=$this->_getParam('loaditem');
		$model = $this->_getModel();
		$model->deleteLoadByUnload($loadingid,$unloadingid);
	    return $this->_helper->redirector->gotoUrl('loading/modifyunload/user/'.$this->_getParam('user').'/item/'.$unloadingid);

    }
	
	public function removeunloadAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$loadingid=$this->_getParam('item');
		$model = $this->_getModel();
		$model->deleteunload($loadingid);
	    return $this->_helper->redirector->gotoUrl('loading/indexunload/user/'.$this->_getParam('user'));

    }
	
	public function delunloadAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$loadingid=$this->_getParam('item');
		$this->view->userid=$this->_getParam('user');
		$model = $this->_getModel();
		$this->view->entry=$model->fetchEntryUnload($loadingid);
    }
	
	public function removeAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$loadingid=$this->_getParam('item');
		$model = $this->_getModel();
		$model->delete($loadingid);
	    return $this->_helper->redirector->gotoUrl('loading/index/user/'.$this->_getParam('user'));

    }
	
	public function deleteAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$this->view->refUser=$modelUsers->fetchEntry($this->_getParam("user"));
		$isAdm=($this->view->user->role['AMM']==1 || $this->_getParam("user")==$this->view->user->id);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$loadingid=$this->_getParam('item');
		$model = $this->_getModel();
		$this->view->entry=$model->fetchEntry($loadingid);
    }
	
	public function newtransAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Trans();
        $form->setAction($this->_helper->url('newtrans'));
        

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
                $model = $this->_getUsersModel();
				$data=$form->getValues();
				$data['data_attivazione']=date('Y-m-d');
				$data['id_modificatore']=$this->view->user->id;
				$data['data_ultima_modifica']=date('Y-m-d');
                $lId=$model->save($data,$this->view->user->id);
				$model->saveTrans($this->view->user->id,array($lId));
				$model->saveRoles($lId,$model->getRoleByCode('TRA'));
				
				$modelMail = $this->_getMailModel();
				$userdata=$model->fetchEntry($this->view->user->id);
				if($userdata["email"]!="")
					$modelMail->sendMail($userdata["email"],"Nuovo trasportatore: ".$data["denominazione"],"L'utente ".$userdata["denominazione"]." ha inserito un nuovo trasportatore: ".$data["denominazione"]);
				
                $this->_redirect('/loading/indexunload/user/'.$this->view->user->id);
            }
        }
        
        $this->view->form = $form;
    }
	
	public function newdestAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Dest();
        $form->setAction($this->_helper->url('newdest'));
        

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
                $model = $this->_getUsersModel();
				$data=$form->getValues();
				$data['data_attivazione']=date('Y-m-d');
				$data['id_modificatore']=$this->view->user->id;
				$data['data_ultima_modifica']=date('Y-m-d');
                $lId=$model->save($data,$this->view->user->id);
				$model->saveDest($this->view->user->id,array($lId));
				$model->saveRoles($lId,$model->getRoleByCode('DES'));
				
				$modelMail = $this->_getMailModel();
				$userdata=$model->fetchEntry($this->view->user->id);
				if($userdata["email"]!="")
					$modelMail->sendMail($userdata["email"],"Nuovo destinatario: ".$data["denominazione"],"L'utente ".$userdata["denominazione"]." ha inserito un nuovo destinatario: ".$data["denominazione"]);
				
                $this->_redirect('/loading/indexunload/user/'.$this->view->user->id);
            }
        }
        
        $this->view->form = $form;
    }
  
    protected function _getModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Loading.php';
            $this->_model = new Model_Loading();
        }
        return $this->_model;
    }
	
	protected function _getUsersModel()
    {
        if (null === $this->_modelUsers) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_modelUsers = new Model_Users();
        }
        return $this->_modelUsers;
    }
	
	protected function _getWasteModel()
    {
        if (null === $this->_modelWaste) {
            require_once APPLICATION_PATH . '/models/Waste.php';
            $this->_modelWaste = new Model_Waste();
        }
        return $this->_modelWaste;
    }
	
	protected function _getMailModel()
    {
        if (null === $this->_modelMail) {
            require_once APPLICATION_PATH . '/models/Mail.php';
            $this->_modelMail = new Model_Mail();
        }
        return $this->_modelMail;
    }
	

}
?>