<?php

/**
 * IndexController - The default controller class
 * 
 * @author
 * @version 
 */

require_once 'Zend/Controller/Action.php';
require_once APPLICATION_PATH . '/models/DbTable/Settings.php';

class MailController extends Zend_Controller_Action 
{
	
	protected $_modelUser;
	protected $_modelMail;
	
    public function indexAction() 
    {
		
		$modelUser = $this->_getUsersModel();
		$modelMail = $this->_getMailModel();
		$modelLoad = $this->_getLoadingModel();
		$modelSettings = $this->_getSettingsModel();
		$dataSettings=$modelSettings->getSettings();
		$entries=$modelUser->fetchEntries();
		
		foreach ($entries as $item){
			if($item["email"]!=""){
				$dataLoad=$modelLoad->getLoadingByUser($item["id"]);
				$msg=str_replace("[DAYS]",$item["giorni_default"],$dataSettings["msg_notify"]);
				$msg=str_replace("[DATE_LOAD]",$dataLoad[0]["data"],$msg);
				
				$modelMail->sendToMail($item["email"],$dataSettings["email_admin"],"Avviso da Ge.Ri. - Gestione Rifiuti On-line",$msg);
			}
		}
    }
	
	protected function _getLoadingModel()
    {
        if (null === $this->_modelLoading) {
            require_once APPLICATION_PATH . '/models/Loading.php';
            $this->_modelLoading = new Model_Loading();
        }
        return $this->_modelLoading;
    }
	
	protected function _getSettingsModel()
    {
        if (null === $this->_modelSettings) {
            require_once APPLICATION_PATH . '/models/Settings.php';
            $this->_modelSettings = new Model_Settings();
        }
        return $this->_modelSettings;
    }
	
	protected function _getUsersModel()
    {
        if (null === $this->_modelUser) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_modelUser = new Model_Users();
        }
        return $this->_modelUser;
    }
	
	protected function _getMailModel()
    {
        if (null === $this->_modelMail) {
            require_once APPLICATION_PATH . '/models/Mail.php';
            $this->_modelMail = new Model_Mail();
        }
        return $this->_modelMail;
    }
	
}
?>