<?php


require_once APPLICATION_PATH . '/forms/MessageForm.php';
require_once APPLICATION_PATH . '/forms/EmailForm.php';

class SystemController extends Zend_Controller_Action 
{
	
    public function indexAction() 
    {
        $this->initView(); 
        $this->view->baseUrl = $this->_request->getBaseUrl(); 
        $this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$modelUsers = $this->_getUsersModel();
		$modelLoads = $this->_getLoadingModel();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray);
    }
	
	public function emailAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Email();

		$modelUsers = $this->_getUsersModel();
		$modelSettings = $this->_getSettingsModel();
		
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$isAdm=($this->view->user->role['AMM']==1);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		$data=$modelSettings->getSettings();
		$form->populate($data);
		
        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
				$data=$form->getValues();
				$modelSettings->setMail($data["msg_notify"]);
				
                return $this->_helper->redirector->gotoUrl('/system/email/');
            }
        }
        $this->view->form = $form;
    }
	
	public function messageAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Message();

		$modelUsers = $this->_getUsersModel();
		
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$isAdm=($this->view->user->role['AMM']==1);
		
		if(!$isAdm){
			$this->_redirect('/'); 
		}
		
		
		
        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
				$data=$form->getValues();
				$data["data"]=date("Y-m-d");
				$isAll=false;
				if(in_array(-1,$data["utente"])){
					$data["utente"]=$modelUsers->fetchEntries();
					$isAll=true;
				}
				foreach($data["utente"] as $item){
					if(!$isAll)
						$data["id_utente"]=$item;
					else
						$data["id_utente"]=$item["id"];
					
					$lId=$modelUsers->sendMessage($data);
				}
                return $this->_helper->redirector->gotoUrl('/system/message/');
            }
        }
        $this->view->form = $form;
    }
	
	protected function _getSettingsModel()
    {
        if (null === $this->_modelSettings) {
            require_once APPLICATION_PATH . '/models/Settings.php';
            $this->_modelSettings = new Model_Settings();
        }
        return $this->_modelSettings;
    }
	
	protected function _getLoadingModel()
    {
        if (null === $this->_modelLoading) {
            require_once APPLICATION_PATH . '/models/Loading.php';
            $this->_modelLoading = new Model_Loading();
        }
        return $this->_modelLoading;
    }
	
	protected function _getUsersModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_model = new Model_Users();
        }
        return $this->_model;
    }
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/login'); 
        } 
    }
	
}
?>