<?php

require_once APPLICATION_PATH . '/forms/UsersForm.php';
require_once APPLICATION_PATH . '/forms/ProfileForm.php';

class UsersController extends Zend_Controller_Action 
{
    protected $_model;
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/login'); 
        } 
    }

    public function indexAction()
    {
        $model = $this->_getModel();
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$rsArray = $model->getRolesByUser($this->view->user->id);
		$this->view->user->role=$model->getActiveRoles($rsArray); 
		$request = $this->getRequest();
		$usersSearchSess=new Zend_Session_Namespace('users');
		$this->view->entries=array();
		
		if ($this->getRequest()->isGet()) {
			
			$get_values=$request->getQuery();
			if($get_values['order']!=""){
				$usersSearchSess->order=$get_values['order'];
				$usersSearchSess->dir=($usersSearchSess->dir=="desc")?$usersSearchSess->dir="asc":$usersSearchSess->dir="desc";
			}
		}

		if($usersSearchSess->order==""){
			$usersSearchSess->order="denominazione";
			$usersSearchSess->dir="desc";
		}
		
		if ($this->getRequest()->isPost()) {
			$post_values=$request->getPost();
			if($post_values['ruolo']>0){
				$usersSearchSess->nome="";
				$usersSearchSess->ruolo=$post_values['ruolo'];
				$this->view->roleSearch=$model->getRoleById($usersSearchSess->ruolo);
				$this->view->entries = $model->getUsersByRole($post_values['ruolo'],$usersSearchSess->order,$usersSearchSess->dir);			
			}else if($post_values['nome']!=""){
				$usersSearchSess->ruolo="";
				$usersSearchSess->nome=$post_values['nome'];
				if($this->view->user->role['AMM'])
					$this->view->entries = $model->getUsersByName($post_values['nome'],null,$usersSearchSess->order,$usersSearchSess->dir);
				else if($this->view->user->role['AZI'])
					$this->view->entries = $model->getUsersByName($post_values['nome'],$this->view->user->id,$usersSearchSess->order,$usersSearchSess->dir);
			}else {
				$usersSearchSess->nome="";
				$usersSearchSess->ruolo="";
				if($this->view->user->role['AMM'])
					$this->view->entries = $model->fetchEntries($usersSearchSess->order,$usersSearchSess->dir);
				else if($this->view->user->role['AZI'])
					$this->view->entries = $model->getUsersByCreator($this->view->user->id,$usersSearchSess->order,$usersSearchSess->dir);
			}
		}else{
			if($usersSearchSess->ruolo!=""){
				$usersSearchSess->nome="";
				$this->view->roleSearch=$model->getRoleById($usersSearchSess->ruolo);
				$this->view->entries = $model->getUsersByRole($usersSearchSess->ruolo,$usersSearchSess->order,$usersSearchSess->dir);
			}else if($usersSearchSess->nome!=""){
				$usersSearchSess->ruolo="";
				if($this->view->user->role['AMM'])
					$this->view->entries = $model->getUsersByName($usersSearchSess->nome,null,$usersSearchSess->order,$usersSearchSess->dir);
				else if($this->view->user->role['AZI'])
					$this->view->entries = $model->getUsersByName($usersSearchSess->nome,$this->view->user->id,$usersSearchSess->order,$usersSearchSess->dir);
			}else{
				if($this->view->user->role['AMM'])
					$this->view->entries = $model->fetchEntries($usersSearchSess->order,$usersSearchSess->dir);
				else if($this->view->user->role['AZI'])
					$this->view->entries = $model->getUsersByCreator($this->view->user->id,$usersSearchSess->order,$usersSearchSess->dir);
			}
		}
		$paginator = new Zend_Paginator(new Zend_Paginator_Adapter_Array($this->view->entries));
		$paginator->setCurrentPageNumber($this->_getParam("page"));
		$this->view->usersSearchSess=$usersSearchSess;
		$this->view->paginator=$paginator;
		$this->view->roles=$model->getRoles();
    }
	
	public function newAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Users();
        $form->setAction($this->_helper->url('new'));
        

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
                $model = $this->_getModel();
				$data=$form->getValues();
				if(count($model->getUsersByUsername($data["username"]))>0){
					$form->_username->addError("Username esistente!")->render();
				}else{
					$lId=$model->save($data,$this->view->user->id);
					$arr=$form->getValues();
					if(is_array($arr['ruoli']))
						$model->saveRoles($lId,$arr['ruoli']);
					else
						$model->saveRoles($lId,$model->getRoleByCode('UTE'));
					
					if(is_array($arr['rifiuti']))
						$model->saveWaste($lId,$arr['rifiuti']);
					
					if(is_array($arr['trasportatore']))
						$model->saveTrans($lId,$arr['trasportatore']);
					
					if(is_array($arr['destinatario']))
						$model->saveDest($lId,$arr['destinatario']);
						
					return $this->_helper->redirector('index');
				}			
              
            }
        }
        
        $this->view->form = $form;
    }
	
	public function modifyAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$userid=$this->_getParam('user');
		$request = $this->getRequest();
        $form = new Form_Users();
        $form->setAction($this->_helper->url('modify/user/'.$userid));
		$model = $this->_getModel();
		$data=$model->fetchEntry($userid);
		
		$rows=$model->getRolesByUser($userid);
		$roles=array();
		foreach($rows as $ruolo){
		  $roles[]=$ruolo['id'];
		}
		$form->setRoles($roles);
		
		$rows=$model->getWasteByUser($userid);
		$waste=array();
		foreach($rows as $item){
		  $waste[]=$item['id'];
		}
		$form->setWaste($waste);
		
		$rows=$model->getTransByUser($userid);
		$trans=array();
		foreach($rows as $item){
		  $trans[]=$item['id_trasportatore'];
		}
	
		$form->setTrans($trans);
		
		$rows=$model->getDestByUser($userid);
		$dest=array();
		foreach($rows as $item){
		  $dest[]=$item['id_destinatario'];
		}
		
		$form->setDest($dest);
		
		$form->populate($data);
		$limite_pagine=50;
		if($data['pagine_libro']<$limite_pagine)
			$form->_paginelibro->addError("Le pagine del libro sono inferiori a ".$limite_pagine."!")->render();

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
				$arr=$form->getValues();
				if(is_array($arr['ruoli']))
					$model->modifyRoles($userid,$arr['ruoli']);
				else
					$model->modifyRoles($userid,$model->getRoleByCode('UTE'));
				
				if(is_array($arr['rifiuti']))
					$model->modifyWaste($userid,$arr['rifiuti']);
					
				if(is_array($arr['trasportatore']))
					$model->modifyTrans($userid,$arr['trasportatore']);
				
				if(is_array($arr['destinatario']))
					$model->modifyDest($userid,$arr['destinatario']);
				
				if(count($model->getUsersByUsername($arr["username"]))>0 && $arr["username"]!=$data["username"]){
					$form->_username->addError("Username esistente!")->render();
				}else{	
					$model->modify($form->getValues(),$userid,$this->view->user->id);
					
					return $this->_helper->redirector('index');
				}
            }
        }
        
        $this->view->form = $form;
    }
	
	public function profileAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$userid=$this->view->user->id;
		$request = $this->getRequest();
        $form = new Form_Profile();
		$model = $this->_getModel();
		$data=$model->fetchEntry($userid);
		
		$rows=$model->getWasteByUser($userid);
		$waste=array();
		foreach($rows as $item){
		  $waste[]=$item['id'];
		}
		$form->setWaste($waste);
		
		$form->populate($data);

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
				$arr=$form->getValues();
				
				if(is_array($arr['rifiuti']))
					$model->modifyWaste($userid,$arr['rifiuti']);
				
				if($arr['password']!=$arr['repassword']){
					$form->_repassword->addError("Le password non coincidono!")->render();	
                }else if(count($model->getUsersByUsername($arr["username"]))>0 && $arr["username"]!=$data["username"]){
					$form->_username->addError("Username esistente!")->render();
				}else{
					$model->modify($arr,$userid,$userid);
                
                	return $this->_redirect('/');
				}
            }
        }
        
        $this->view->form = $form;
    }
	
	public function removeAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$userid=$this->_getParam('user');
		$model = $this->_getModel();
		$model->delete($userid);
	    return $this->_helper->redirector('index');

    }
	
	public function deleteAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$userid=$this->_getParam('user');
		$model = $this->_getModel();
		$this->view->entry=$model->fetchEntry($userid);
    }
  
    protected function _getModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_model = new Model_Users();
        }
        return $this->_model;
    }
	
	public function wasteAction()
    {
        $model = $this->_getModel();
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$rsArray = $model->getRolesByUser($this->view->user->id);
		$this->view->user->role=$model->getActiveRoles($rsArray); 
		$request = $this->getRequest();
		$this->view->entries=array();
		
		$this->view->entries = $model->getWasteByUser($this->_getParam("user"));
		
		if ($this->getRequest()->isPost()) {
			$data=$request->getPost();
			foreach($this->view->entries as $item){
				$data['id_utente']=$this->_getParam("user");
				$data['id_rifiuto']=$item['id'];
				$model->updateWaste($data['id_utente'],$data['id_rifiuto'],$data['default'.$item['id']]);
			}
			$this->_redirect('/users/waste/user/'.$this->_getParam("user")); 
		}
    }

}
?>