<?php

require_once APPLICATION_PATH . '/forms/WasteForm.php';

class WasteController extends Zend_Controller_Action 
{
    protected $_model;
	protected $_modelUsers;
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/login'); 
        } 
    }

    public function indexAction()
    {
        $model = $this->_getModel();
		$modelUsers = $this->_getUsersModel();
		$this->view->user = Zend_Auth::getInstance()->getIdentity();
		$rsArray = $modelUsers->getRolesByUser($this->view->user->id);
		$this->view->user->role=$modelUsers->getActiveRoles($rsArray); 
		$request = $this->getRequest();
		$wasteSearchSess=new Zend_Session_Namespace('waste');
		$this->view->entries=array();
		
		if ($this->getRequest()->isGet()) {
			$get_values=$request->getQuery();
			if($get_values['order']!=""){
				$wasteSearchSess->order=$get_values['order'];
				$wasteSearchSess->dir=($wasteSearchSess->dir=="desc")?$wasteSearchSess->dir="asc":$wasteSearchSess->dir="desc";
			}else{
				if($wasteSearchSess->order==""){
					$wasteSearchSess->order="descrizione";
					$wasteSearchSess->dir="desc";
				}
			}
		}
		
		if ($this->getRequest()->isPost()) {
			$post_values=$request->getPost();
			if($post_values['nome']!=""){
				$wasteSearchSess->nome=$post_values['nome'];
				$this->view->entries = $model->getWasteByName($post_values['nome'],$wasteSearchSess->order,$wasteSearchSess->dir);
			}else {
				$usersSearchSess->nome="";
				$this->view->entries = $model->fetchEntries($wasteSearchSess->order,$wasteSearchSess->dir);
			}
		}else{
			if($wasteSearchSess->nome!=""){
				$this->view->entries = $model->getWasteByName($wasteSearchSess->nome,$wasteSearchSess->order,$wasteSearchSess->dir);
			}else{
				$this->view->entries = $model->fetchEntries($wasteSearchSess->order,$wasteSearchSess->dir);
			}
		}
		$paginator = new Zend_Paginator(new Zend_Paginator_Adapter_Array($this->view->entries));
		$paginator->setCurrentPageNumber($this->_getParam("page"));
		$this->view->wasteSearchSess=$wasteSearchSess;
		$this->view->paginator=$paginator;
    }
	
	public function newAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Waste();
        $form->setAction($this->_helper->url('new'));
        

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
                $model = $this->_getModel();
                $lId=$model->save($form->getValues());
                return $this->_helper->redirector('index');
            }
        }
        
        $this->view->form = $form;
    }
	
	public function modifyAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$wasteid=$this->_getParam('waste');
		$request = $this->getRequest();
        $form = new Form_Waste();
        $form->setAction($this->_helper->url('modify/waste/'.$wasteid));
		$model = $this->_getModel();
		$data=$model->fetchEntry($wasteid);
		
		$form->populate($data);

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                $model->modify($form->getValues(),$wasteid);
                
                return $this->_helper->redirector('index');
            }
        }
        
        $this->view->form = $form;
    }
	
	public function removeAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$wasteid=$this->_getParam('waste');
		$model = $this->_getModel();
		$model->delete($wasteid);
	    return $this->_helper->redirector('index');

    }
	
	public function deleteAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$wasteid=$this->_getParam('waste');
		$model = $this->_getModel();
		$this->view->entry=$model->fetchEntry($wasteid);
    }
  
    protected function _getModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Waste.php';
            $this->_model = new Model_Waste();
        }
        return $this->_model;
    }
	
	protected function _getUsersModel()
    {
        if (null === $this->_modelUsers) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_modelUsers = new Model_Users();
        }
        return $this->_modelUsers;
    }

}
?>