<?php

/**
 * IndexController - The default controller class
 * 
 * @author
 * @version 
 */

require_once 'Zend/Controller/Action.php';
require_once APPLICATION_PATH . '/forms/UnloadWizForm.php';
require_once APPLICATION_PATH . '/forms/TransForm.php';
require_once APPLICATION_PATH . '/forms/DestForm.php';

class WizardController extends Zend_Controller_Action 
{
	/**
	 * The default action - show the home page
	 */
    public function indexAction() 
    {
        $this->initView(); 
        $this->view->baseUrl = $this->_request->getBaseUrl(); 
        $this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$model = $this->_getModel();
		$modelMail = $this->_getMailModel();
		
		$this->view->entries = $model->getWasteByUser($this->view->user->id);
		
		if ($this->getRequest()->isPost()) {
			$data=$this->getRequest()->getPost();
			$userdata=$model->fetchEntry($this->view->user->id);
			$msg=chr(13).chr(10);
			foreach($this->view->entries as $item){
				$msg.=$item["descrizione"]." : ".$data['waste'.$item['id']].chr(13).chr(10);
			}
			$modelMail->sendMail($userdata["email"],"Nuovo carico. Utente: ".$userdata["denominazione"],"L'utente ".$userdata["denominazione"]." in data ".date("d-M-Y")." ha inserito un nuovo carico: ".$msg);
			$this->_redirect('/wizard/sended'); 
		}
    }
	
	public function unloadAction() 
    {
        $this->initView(); 
        $this->view->baseUrl = $this->_request->getBaseUrl(); 
        $this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$form = new Form_UnloadWiz();
		$form->setWasteSelect($this->view->user->id);
		//$form->setAction($this->_helper->url('/wizard/unload/user/'.$this->view->user->id));
		$model = $this->_getModel();
		$modelMail = $this->_getMailModel();
		
		$this->view->entries = $model->getWasteByUser($this->view->user->id);
		
		if ($this->getRequest()->isPost()) {
			$data=$this->getRequest()->getPost();
			$userdata=$model->fetchEntry($this->view->user->id);
			$msg=chr(13).chr(10)."Rifiuto: ".chr(13).chr(10);
			
			$msg.=$data["rifiuto"].chr(13).chr(10);
			
			$msg.="Data: ".$data["data"].chr(13).chr(10);
			
			$msg.="Data formulario: ".$data["data_formulario"].chr(13).chr(10);
			
			$msg.="Formulario N.: ".$data["formulario_num_p1"]." ".$data["formulario_num_p2"]." ".$data["formulario_num_p3"].chr(13).chr(10);
			
			$msg.="Quantita' dichiarata: ".$data["qt_dichiarata"]." ".$data["id_um_qtd"].chr(13).chr(10);
			
			$msg.="Quantita' a destino: ".$data["qt_destino"]." ".$data["id_um_qtr"].chr(13).chr(10);
			
			$trs=$model->fetchEntry($data["id_trasportatore"]);
			$des=$model->fetchEntry($data["id_destinatario"]);
			
			$msg.="Trasportatore: ".$trs["denominazione"].chr(13).chr(10);
			
			$msg.="Destinatario: ".$des["denominazione"].chr(13).chr(10);
			
			
			$modelMail->sendMail($userdata["email"],"Nuovo scarico. Utente: ".$userdata["denominazione"],"L'utente ".$userdata["denominazione"]." in data ".date("d-M-Y")." ha inoltrato un nuovo scarico: ".$msg);
			
			$this->_redirect('/wizard/sended'); 
		}
		
		$this->view->form = $form;
    }
	
	public function newtransAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Trans();
        $form->setAction($this->_helper->url('newtrans'));
        

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
                $model = $this->_getModel();
				$data=$form->getValues();
				$data['data_attivazione']=date('Y-m-d');
				$data['id_modificatore']=$this->view->user->id;
				$data['data_ultima_modifica']=date('Y-m-d');
                $lId=$model->save($data,$this->view->user->id);
				$model->saveTrans($this->view->user->id,array($lId));
				$model->saveRoles($lId,$model->getRoleByCode('TRA'));
				
				$modelMail = $this->_getMailModel();
				$userdata=$model->fetchEntry($this->view->user->id);
				if($userdata["email"]!="")
					$modelMail->sendMail($userdata["email"],"Nuovo trasportatore: ".$data["denominazione"],"L'utente ".$userdata["denominazione"]." ha inserito un nuovo trasportatore: ".$data["denominazione"]);
				
                $this->_redirect('/wizard/unload/user/'.$this->view->user->id);
            }
        }
        
        $this->view->form = $form;
    }
	
	public function newdestAction()
    {
		$this->view->user = Zend_Auth::getInstance()->getIdentity(); 
        $request = $this->getRequest();
        $form = new Form_Dest();
        $form->setAction($this->_helper->url('newdest'));
        

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {
                
                $model = $this->_getModel();
				$data=$form->getValues();
				$data['data_attivazione']=date('Y-m-d');
				$data['id_modificatore']=$this->view->user->id;
				$data['data_ultima_modifica']=date('Y-m-d');
                $lId=$model->save($data,$this->view->user->id);
				$model->saveDest($this->view->user->id,array($lId));
				$model->saveRoles($lId,$model->getRoleByCode('DES'));
				
				$modelMail = $this->_getMailModel();
				$userdata=$model->fetchEntry($this->view->user->id);
				if($userdata["email"]!="")
					$modelMail->sendMail($userdata["email"],"Nuovo destinatario: ".$data["denominazione"],"L'utente ".$userdata["denominazione"]." ha inserito un nuovo destinatario: ".$data["denominazione"]);
				
                $this->_redirect('/wizard/unload/user/'.$this->view->user->id);
            }
        }
        
        $this->view->form = $form;
    }
	
	public function sendedAction() 
    {
        $this->initView(); 
        $this->view->baseUrl = $this->_request->getBaseUrl(); 
        $this->view->user = Zend_Auth::getInstance()->getIdentity(); 
    }
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/private'); 
        } 
    }
	
	protected function _getModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_model = new Model_Users();
        }
        return $this->_model;
    }
	
	
	protected function _getMailModel()
    {
        if (null === $this->_modelMail) {
            require_once APPLICATION_PATH . '/models/Mail.php';
            $this->_modelMail = new Model_Mail();
        }
        return $this->_modelMail;
    }
	
}
?>