<?php
require_once APPLICATION_PATH . '/models/Loading.php';
require_once APPLICATION_PATH . '/models/Users.php';

class Form_Message extends Zend_Form
{
	
	protected $_users;
	
	private $textDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'message')),
	);
	
	private $selectDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'multiple')),
	);
    
	public function init()
    {
        
        $this->setMethod('post');
		
		$this->_users = new Zend_Form_Element_Multiselect('utente');
		$this->_users->setLabel('Utente:');
		$this->_users->setDecorators($this->selectDecorators);
		$table=new Users();
		$rows=$table->fetchAll()->toArray();
		if(!empty($rows)){
			$this->_users->addMultiOption(-1, "-----TUTTI-----");
			foreach($rows as $item){
			  $this->_users->addMultiOption($item['id'], $item['denominazione']);
			}
		}

		$this->addElement($this->_users);

		
		$this->addElement('textarea', 'testo', array(
            'label'      => 'Note:',
            'filters'    => array('StringTrim'),
			'decorators' => $this->textDecorators,
        ));
		
        $this->addElement('submit', 'submit', array(
            'label'    => 'Conferma'
        ));
    }

}
?>