<?php
require_once APPLICATION_PATH . '/models/Users.php';

class Form_Profile extends Zend_Form
{

	protected $_wasteSelect;
	public $_username;
	public $_repassword;
	
	private $textDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'field')),
	);
	
	private $selectDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'multiple')),
	);
    
	public function init()
    {
        
        $this->setMethod('post');
        
		
		$this->_username = new Zend_Form_Element_Text('username', array(
            'label'      => 'Username:',
			'size'   => 10,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement($this->_username);
		
		$this->addElement('password', 'password', array(
            'label'      => 'Password:',
			'size'   => 10,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->_repassword = new Zend_Form_Element_Password('repassword', array(
            'label'      => 'Conferma password:',
			'size'   => 10,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement($this->_repassword);
		
		
		$this->_wasteSelect = new Zend_Form_Element_Multiselect('rifiuti');
		$this->_wasteSelect->setLabel('Rifiuti:');
		$this->_wasteSelect->setDecorators($this->selectDecorators);
		$table=new UWaste();
		$rows=$table->fetchAll()->toArray();
		if(!empty($rows)){
			foreach($rows as $item){
			  $this->_wasteSelect->addMultiOption($item['id'], $item['descrizione']);
			}
		}

		$this->addElement($this->_wasteSelect);

        $this->addElement('submit', 'submit', array(
            'label'    => 'Conferma'
        ));
    }
	
	public function setWaste($data)
	{
		$this->_wasteSelect->setValue($data);
	} 
}
?>