<?php
require_once APPLICATION_PATH . '/models/Loading.php';
require_once APPLICATION_PATH . '/models/Users.php';

class addTransButton extends Zend_Form_Element_Xhtml
{
        public $helper = 'formNote';
}

class addDestButton extends Zend_Form_Element_Xhtml
{
        public $helper = 'formNote';
}

class Form_UnloadWiz extends Zend_Form
{
	
	protected $_udmQtdSelect;
	protected $_udmQtrSelect;
	protected $_transporters;
	protected $_destinatari;
	protected $_transButton;
	protected $_destButton;
	public $_formulario;
	protected $_qtDichiarata;
	protected $_qtDestino;
	protected $_wasteSelect;
	
	private $buttonDateDecorators = array(
		'ViewHelper',
		array(array('data' => 'HtmlTag'), array('tag' => 'span', 'class' => 'buttondate'))
	);
	
	private $dateDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'span')),
	);
	
	private $textDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'field')),
	);
	
	private $umQtDecorators = array(
		'ViewHelper',
		array(array('data' => 'HtmlTag'), array('tag' => 'span', 'class' => 'qt'))
	);
	
	private $qtDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'div')),
		array('HtmlTag', array('tag' => 'span')),
	);
	
	private $formDecorators = array(
		array('ViewHelper'),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'span', 'class' => 'field')),
	);
	
	private $formLabelDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Label', array('tag' => 'div')),
		array('HtmlTag', array('tag' => 'span', 'class' => 'field')),
	);
	
	private $proDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span', 'class' => 'progressivo')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'progressivo')),
	);
    
	public function init()
    {
        
        $this->setMethod('post');
		
		$this->_wasteSelect = new Zend_Form_Element_Select('rifiuto');
		$this->_wasteSelect->setLabel('Rifiuto:');		
		$this->addElement($this->_wasteSelect);
		

        $this->addElement('text', 'data', array(
            'label'      => 'Data:',
			'id'      => 'data',
			'size'   => 10,
			'readonly'      => true,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 10))
            ),
			'decorators' => $this->dateDecorators,
        ));
		
		$this->addElement('button', 'calendar', array(
            'label'      => 'Scegli una data',
			'onClick' => 'makeCalendar(document.getElementById(\'data\'));',
			'decorators' => $this->buttonDateDecorators,
        ));
		
		$user = Zend_Auth::getInstance()->getIdentity();
		$table=new Model_Users();
		$rsArray = $table->getRolesByUser($user->id);
		$role=$table->getActiveRoles($rsArray); 
		
		$this->addElement('text', 'data_formulario', array(
            'label'      => 'Formulario Data:',
			'id'      => 'data_formulario',
			'size'   => 10,
			'readonly'      => true,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 10))
            ),
			'decorators' => $this->dateDecorators,
        ));
		
		$this->addElement('button', 'calendar2', array(
            'label'      => 'Scegli una data',
			'onClick' => 'makeCalendar(document.getElementById(\'data_formulario\'));',
			'decorators' => $this->buttonDateDecorators,

        ));
		
		$this->_formulario = new Zend_Form_Element_Text('formulario_num_p1', array(
            'label'      => 'Formulario N.:',
			'size'   => 5,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 10))
            ),
			'decorators' => $this->formLabelDecorators,
        ));
		
		$this->addElement($this->_formulario);
		
		$this->addElement('text', 'formulario_num_p2', array(
			'size'   => 3,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 5))
            ),
			'decorators' => $this->formDecorators,
        ));
		
		$this->addElement('text', 'formulario_num_p3', array(
			'label'      => '/',
			'size'   => 4,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 5))
            ),
			'decorators' => $this->formDecorators,
        ));
		
		$this->_qtDichiarata = new Zend_Form_Element_Text('qt_dichiarata', array(
            'label'      => 'Quantita\' dichiarata:',
            'required'   => true,
			'size'   => 5,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'Float'),
				 array('validator' => 'StringLength', 'options' => array(0, 5))
            ),
			'decorators' => $this->qtDecorators,
        ));
		
		$this->addElement($this->_qtDichiarata);
		
		$this->_udmQtdSelect = new Zend_Form_Element_Select('id_um_qtd');
		$this->_udmQtdSelect->setDecorators($this->umQtDecorators);
		$table=new UdM();
		$rows=$table->fetchAll()->toArray();
		if(!empty($rows)){
			foreach($rows as $item){
			  $this->_udmQtdSelect->addMultiOption($item['unita_misura'], $item['unita_misura']);
			}
		}
		
		$this->addElement($this->_udmQtdSelect);
		
		$this->_qtDestino = new Zend_Form_Element_Text('qt_destino', array(
            'label'      => 'Quantita\' verificata a destino:',
			'size'   => 5,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'Float'),
				 array('validator' => 'StringLength', 'options' => array(0, 5))
            ),
			'decorators' => $this->qtDecorators,
        ));
		
		$this->addElement($this->_qtDestino);
		
		$this->_udmQtrSelect = new Zend_Form_Element_Select('id_um_qtr');
		$this->_udmQtrSelect->setDecorators($this->umQtDecorators);
		$table=new UdM();
		$rows=$table->fetchAll()->toArray();
		if(!empty($rows)){
			foreach($rows as $item){
			  $this->_udmQtrSelect->addMultiOption($item['unita_misura'], $item['unita_misura']);
			}
		}
		
		$this->addElement($this->_udmQtrSelect);
		
		
		$this->_transporters = new Zend_Dojo_Form_Element_FilteringSelect('id_trasportatore');
		$this->_transporters->setLabel('Trasportatore:')
		->setAutoComplete(true)
		->setStoreId('userStore')
		->setStoreType('dojo.data.ItemFileReadStore')
		->setStoreParams(array('url'=>'/loading/translist/user/'.$user->id))
		->setAttrib("searchAttr" , "denominazione")
		->setRequired(true);
		
		
		$this->addElement($this->_transporters);
		if(!$isAdm){
			
			$this->_transButton = new addTransButton('trans');
			$this->_transButton->setValue("<div class=\"buttontrans\">Per creare un nuovo trasportatore cliccare sul tasto sottostante. Verrete reindirizzati in un'altra pagina e tutti i dati inseriti in questo modulo verranno persi.<br />
			<a href='/wizard/newtrans/user/".$user->id."'>Aggiungi Trasportatore >></a>
			</div>");
			$this->addElement($this->_transButton);
		}
		
		$this->_destinatari = new Zend_Dojo_Form_Element_FilteringSelect('id_destinatario');
		$this->_destinatari->setLabel('Destinatario:')
		->setAutoComplete(true)
		->setStoreId('userStore2')
		->setStoreType('dojo.data.ItemFileReadStore')
		->setStoreParams(array('url'=>'/loading/destlist/user/'.$user->id))
		->setAttrib("searchAttr" , "denominazione")
		->setRequired(true);
		
		
		$this->addElement($this->_destinatari);
		if(!$isAdm){
			
			$this->_destButton = new addDestButton('dest');
			$this->_destButton->setValue("<div class=\"buttontrans\">Per creare un nuovo destinatario cliccare sul tasto sottostante. Verrete reindirizzati in un'altra pagina e tutti i dati inseriti in questo modulo verranno persi.<br />
			<a href='/wizard/newdest/user/".$user->id."'>Aggiungi Destinatario >></a>
			</div>");
			$this->addElement($this->_destButton);
		}

        $this->addElement('submit', 'submit', array(
            'label'    => 'Conferma'
        ));
    }
	
	public function setQtDichiarata($value)
	{
		$this->_qtDichiarata->setValue($value);
	}
	
	public function setQtDestino($value)
	{
		$this->_qtDestino->setValue($value);
	}
	
	public function setTrans($value)
	{
		$this->_transporters->setValue($value);
	}
	
	public function setDest($value)
	{
		$this->_destinatari->setValue($value);
	}
	
	public function getWaste()
	{
		return $this->_wasteSelect->getValue();
	}
	
	public function setWasteSelect($userid)
	{
		$table=new Model_Users();
		$rows=$table->getWasteByUser($userid);
		
		
		if(!empty($rows)){
			foreach($rows as $waste){
			  $this->_wasteSelect->addMultiOption($waste['cer']." - ".$waste['descrizione'], $waste['cer']." - ".$waste['descrizione']);
			}
		}
	}
}
?>