<?php
require_once APPLICATION_PATH . '/models/Waste.php';

class Form_Waste extends Zend_Form
{

    
	public function init()
    {
        
        $this->setMethod('post');

        $this->addElement('text', 'cer', array(
            'label'      => 'C.E.R.:',
            'required'   => true,
			'size'   => 10,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 50))
            )
        ));
		
		
		$this->addElement('select', 'stato_fisico', array(
            'label'      => 'Stato fisico:',
            'required'   => true,
			'MultiOptions' => array("Liquido" => "Liquido", "Solido" => "Solido", "Gassoso" => "Gassoso")
        ));
		
		
		$this->addElement('text', 'classi_pericolosita', array(
            'label'      => 'Classi di pericolosita\':',
			'size'   => 10,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 100))
            )
        ));
		
		$this->addElement('textarea', 'descrizione', array(
            'label'      => 'Descrizione:',
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 255))
            )
        ));
		
		$this->addElement('text', 'cod_smaltimento', array(
            'label'      => 'Codice Smaltimento:',
			'size'   => 20,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            )
        ));
		
		$this->addElement('text', 'cod_recupero', array(
            'label'      => 'Codice Recupero:',
			'size'   => 20,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            )
        ));

        $this->addElement('submit', 'submit', array(
            'label'    => 'Conferma'
        ));
    }
}
?>