<?php
require_once APPLICATION_PATH . '/models/DbTable/Waste.php';

class Model_Waste {
    protected $_table;
    
 
	public function fetchEntries($orderby="descrizione",$orderdir="desc")
    {
		$table=new Waste();
		$select = $table->select()->order($orderby.' '.$orderdir);
        return $table->fetchAll($select)->toArray();
    }
	
	 
    public function fetchEntry($id)
    {
        $table = new Waste();
        $select = $table->select()->where('id = ?', $id);
		$select=$table->fetchRow($select);
		if($select)
        	return $select->toArray();
		else
			return null;
    }
	
	public function getWasteByName($name,$orderby="descrizione",$orderdir="desc")
    {
        $table = new Waste();
		$select = $table->select()->where('descrizione LIKE ?', '%'.$name.'%')->order($orderby.' '.$orderdir);
        return $table->fetchAll($select)->toArray();
    }
	
	public function save(array $data)
    {
        $table=new Waste();
        $fields = $table->info(Zend_Db_Table_Abstract::COLS);
        foreach ($data as $field => $value) {
            if (!in_array($field, $fields)) {
                unset($data[$field]);
            }
        }
		
		$table->insert($data);
		
        return $table->getAdapter()->lastInsertId();
    }
	
	
	
	public function modify(array $data,$wasteid)
    {
        $table=new Waste();
        $fields = $table->info(Zend_Db_Table_Abstract::COLS);
        foreach ($data as $field => $value) {
            if (!in_array($field, $fields)) {
                unset($data[$field]);
            }
        }
		
		$where=$table->getAdapter()->quoteInto('id = ?', $wasteid);
		return $table->update($data,$where);
    }
	
	public function delete($wasteid)
    {
        $table=new Waste();
		$where=$table->getAdapter()->quoteInto('id = ?', $wasteid);
		return $table->delete($where);
    }
	
	
}

?>